#include <stdint.h>
#include <propeller.h>
#include "ws2812.h"

#define LED_PIN     15
#define LED_COUNT   16

uint32_t Chakras[] = {
    COLOR_RED,
    COLOR_ORANGE,
    COLOR_YELLOW, 
    COLOR_GREEN,
    COLOR_BLUE,
    COLOR_INDIGO
};
int Chackras_count = sizeof(Chakras) / sizeof(uint32_t);

int main(void)
{
    uint32_t colors[LED_COUNT];
    int cog;
        
    ws2812_clock_init();
    
    memset(colors, 0, sizeof(colors));
    
    if ((cog = ws2812_init()) < 0)
        return 1;
        
    //ws2812_fill_wheel_continuous_dim(colors, LED_COUNT, LED_COUNT+5, 128, 100);
    //ws2812_fill_wheel_continuous(colors, LED_COUNT, LED_COUNT+5, 100);
    for (;;)ws2812_chase(colors, LED_COUNT, Chakras, Chackras_count, 150);
        
    for (;;) {
        ws2812_fill(colors, LED_COUNT, COLOR_RED);
        ws2812_pause(1000);
        ws2812_fill(colors, LED_COUNT, COLOR_GREEN);
        ws2812_pause(1000);
        ws2812_fill(colors, LED_COUNT, COLOR_BLUE);
        ws2812_pause(1000);
        ws2812_fill(colors, LED_COUNT, COLOR_WHITE);
        ws2812_pause(1000);
    }
        
    cogstop(cog);
    
    return 0;
}
