#ifndef __WS2812_H__
#define __WS2812_H__

#include <stdint.h>

#if defined(__cplusplus)
extern "C" {
#endif

#define SWAP_NONE   0   // use with the ws2811
#define SWAP_RG     1   // use with the ws2812

#define COLOR(r, g, b)      (((r) << 16) | ((g) << 8) | (b))
#define SCALE(x, l)         ((x) * (l) / 255)
#define COLORX(r, g, b, l)  ((SCALE(r, l) << 16) | (SCALE(g, l) << 8) | SCALE(b, l))

//                         RRGGBB
#define COLOR_BLACK      0x000000
#define COLOR_RED        0xFF0000
#define COLOR_GREEN      0x00FF00
#define COLOR_BLUE       0x0000FF
#define COLOR_WHITE      0xFFFFFF
#define COLOR_CYAN       0x00FFFF
#define COLOR_MAGENTA    0xFF00FF
#define COLOR_YELLOW     0xFFFF00
#define COLOR_CHARTREUSE 0x7FFF00
#define COLOR_ORANGE     0xFF6000
#define COLOR_AQUAMARINE 0x7FFFD4
#define COLOR_PINK       0xFF5F5F
#define COLOR_TURQUOISE  0x3FE0C0
#define COLOR_REALWHITE  0xC8FFFF
#define COLOR_INDIGO     0x3F007F
#define COLOR_VIOLET     0xBF7FBF
#define COLOR_MAROON     0x320010
#define COLOR_BROWN      0x0E0600
#define COLOR_CRIMSON    0xDC283C
#define COLOR_PURPLE     0x8C00FF

int ws2812_init(void);
int ws2812b_init(void);
int ws_init(int usreset, int ns0h, int ns0l, int ns1h, int ns1l, int swaprg);
void ws2812_execute(int pin, uint32_t *colors, int count);
void ws2812_clock_init(void);
void ws2812_fill(uint32_t *colors, int count, uint32_t color);
void ws2812_fill_wheel(uint32_t *colors, int count, int delay);
void ws2812_fill_wheel_continuous(uint32_t *colors, int count, int samples, int delay);
void ws2812_fill_wheel_continuous_dim(uint32_t *colors, int count, int samples, int brightness, int delay);
void ws2812_fill_wheel_dim(uint32_t *colors, int count, int delay, int brightness);
void ws2812_chase(uint32_t *colors, int count, uint32_t *pattern, int pcount, int delay);
uint32_t ws2812_wheel(int pos);
uint32_t ws2812_wheel_dim(int pos, int brightness);
void ws2812_pause(int ms);

#if defined(__cplusplus)
}
#endif

#endif
