#include <propeller.h>
#include "ws2812.h"

void ws2812_chase(uint32_t *colors, int count, uint32_t *pattern, int pcount, int delay)
{
    int base, idx, i;
    
// Performs color chase 

    for (base = 0; base < pcount; ++base) {     // do all colors in table
        idx = base;                             // start at base
        for (i = 0; i < count; ++i) {           // loop through connected leds
            colors[i] = pattern[idx];           // update channel color
            if (++idx >= pcount)                // past end of list?
                idx = 0;                        // yes, reset
        }
        ws2812_execute(15, colors, count);      // update all LEDs
        ws2812_pause(delay);                    // set movement speed
    }
}
